<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="defaultData"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";
import {useSettingStore} from "~/stores/setting.js";

const props = defineProps({
    formModel: {
        required: true,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $settingStore = useSettingStore();
const i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const permissions = ref([]);

const defaultData = ref({});

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'username',
            label: i18n.t('username'),
            readonly: true,
            disabled: true,
        },
        {
            type: 'text',
            name: 'name',
            label: i18n.t('name'),
        },
        {
            type: 'email',
            name: 'email',
            label: i18n.t('email'),
        },
        {
            type: 'contact',
            label: i18n.t('contact_number'),
        },
        {
            type: 'select',
            name: 'force_ranking',
            label: i18n.t('force_ranking'),
            options: [
                {value: '0', text: i18n.t('ranking_0')},
                {value: '1', text: i18n.t('ranking_1')},
                {value: '2', text: i18n.t('ranking_2')},
                {value: '3', text: i18n.t('ranking_3')},
            ],
            placeholder: i18n.t('please_select')
        },
        {
            type: 'password',
            name: 'new_password',
            label: i18n.t('new_password'),
            placeholder: i18n.t('leave_blank_if_not_changing'),
        },
        {
            type: 'password',
            name: 'new_password_confirmation',
            label: i18n.t('new_password_confirmation'),
            placeholder: i18n.t('leave_blank_if_not_changing'),
        },
        {
            type: 'pin',
            name: 'new_password2',
            label: i18n.t('new_password2'),
            placeholder: i18n.t('leave_blank_if_not_changing'),
        },
        {
            type: 'pin',
            name: 'new_password2_confirmation',
            label: i18n.t('new_password2_confirmation'),
            placeholder: i18n.t('leave_blank_if_not_changing'),
        }
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/user/user/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/user/user/build_form', {
            id: props.formModel.id,
        });

        if (data.model) {
            defaultData.value = {...data.model};
            model.value = data.model;
        }

        await $settingStore.fetchSettings();

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
